package org.garret.metronome;

import javax.microedition.lcdui.*;

public class SettingsForm extends Form implements CommandListener { 
    Metronome   metronome;
    Gauge       frequency;
    Gauge       duration;
    Gauge       volume;
    ChoiceGroup flags;

    static final int MAX_FREQUENCY = 13288;
    static final int MAX_DURATION = 1000;
    static final int MAX_VOLUME = 255;

    SettingsForm(Metronome metronome) { 
        super(Locale.SETTINGS);        
        this.metronome = metronome;
        frequency = new Gauge(Locale.FREQUENCY, true, MAX_FREQUENCY, metronome.frequency);
        duration = new Gauge(Locale.DURATION, true, MAX_DURATION, metronome.duration);
        volume = new Gauge(Locale.VOLUME, true, MAX_VOLUME, metronome.volume);
        flags = new ChoiceGroup(Locale.SIGNAL, Choice.MULTIPLE, new String[] { Locale.VIBRA, Locale.BACKLIGHT }, null);
        boolean[] selectedFlags = new boolean[2];
        if ((metronome.flags & Metronome.VIBRA) != 0) {
            selectedFlags[0] = true;
        }
        if ((metronome.flags & Metronome.BACKLIGHT) != 0) {
            selectedFlags[1] = true;
        }
        flags.setSelectedFlags(selectedFlags);
        append(frequency);
        append(duration);
        append(volume);
        append(flags);
        addCommand(Metronome.SAVE_CMD);
        addCommand(Metronome.BACK_CMD);
        setCommandListener(this);
        Display.getDisplay(metronome).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == Metronome.SAVE_CMD) { 
            boolean[] selectedFlags = new boolean[2];
            flags.getSelectedFlags(selectedFlags);
            metronome.flags = 0;
            if (selectedFlags[0]) {
                metronome.flags |= Metronome.VIBRA;
            } 
            if (selectedFlags[1]) { 
                metronome.flags |= Metronome.BACKLIGHT;
            }                 
            metronome.frequency = frequency.getValue();
            metronome.duration = duration.getValue();
            metronome.volume = volume.getValue();
            metronome.saveSettings();
            metronome.initSound();
        }                
        Display.getDisplay(metronome).setCurrent(metronome.canvas);
    }
}
           

   